#!/usr/bin/wish -f
# dial_ppp.tcl
# (c) 1996 Graham Swallow - Raven 1996 May Twenty (ish)
# (c) 1996 Graham Swallow - Raven 1996 July 1 (ish)
# this file may be freely distributed for personal use until Dec 1997
# by then either you or I must come up with something better 
# after then you should not use it, distribute it or derive from it
# minor edits allowed, to reconfigure it to your system, your callers
# please leave the Raven items in the menu, thanks
# if that is a problem, please call
# gps@trix.dircon.co.uk
# and I'll sell you a mass of code for a tenner!
# http://www.users.dircon.co.uk/~trix

#-- dial_ppp_main --#

# the dial_ppp menu
# your system might also display ifconfig reports
# tk menus
# the description texts are not displayed
# I use a the parent work-benches .msg line and .cmd display
# Encourage brief desc lines, by indenting by 0 on such lines
# other coding rules also broken

#--- edit this function ---#

proc fn_dial_ppp_main { p } {
 fn_gen_button       $p [new_tag] "Exit" "exit" "TTFN" ;# "Let child zombies go"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp tdc" "Connect to TDC"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp demon" "Connect to demon"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp wherever" "Connect to wherever"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp work" "Connect to work"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp home" "Connect to home"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp cut" "Dis-Connect"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp id" "After suid, during script"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp list" "For menu builders"
 fn_cmd_button_prtc  $p [new_tag] "dial_ppp help" "For menu builders"
 fn_gen_button       $p [new_tag] "browse Raven" "dial_Raven" "Browse the Raven magazine" 
}
#--- no more edits required ---#

#-- browse Raven menu added --#

proc browse { w url } {
	set title $url
	set desc "run browser on $url"
#	set p [ pop_up_frm $w .frm $title ]
	set p [ pop_up_frm $w .frm $title ]
  fn_cmd_button_x    $p [new_tag] "netscape $url" $desc
  fn_cmd_button_x    $p [new_tag] "netscape -remote 'OpenURL($url)'" $desc
  fn_cmd_button_x    $p [new_tag] "mosaic   $url" $desc
  fn_cmd_button_x    $p [new_tag] "arena    $url" $desc
  fn_cmd_button_x    $p [new_tag] "chimera  $url" $desc
  fn_cmd_button_prtc $p [new_tag] "lynx     $url" $desc

# edit-able field - press Return to regenerate menu

  global URL1
  set URL1 $url
  set fld $p.url
  entry $fld -textvariable URL1 -relief sunken -bd 2 -bg white
#  bind $w <Any-Enter> "focus $w"
  bind $fld <Any-Enter> "focus $fld"
  bind $fld "<Return>" "browse_edited_url $w"
  pack_line $fld

##	this (nested) function needed because I don't know how to use VARS in binds

	proc browse_edited_url {w} {
		global URL1
		browse $w $URL1
	}
}

# BUGS # loses focus on dismiss button
# above code is as it is because the following didn-t work
# sometimes its just easier to do it the explicit way 
#
#   set fld [ fn_gen_field $p "URL" .url URL1 $desc ]
#   bind $fld <Return> "browse_edited_url $URL1"

proc dial_Raven {} {
  set p [ pop_up_frm .raven .frm "Browse Raven" ]
  set URL_SUN  "http://sunsite.unc.edu/pub/Linux/docs/Raven/SSR01/Raven01.html"
  set URL_SUN  "http://sunsite.unc.edu/pub/Linux/docs/Raven/ssr01/Raven01.html"
  set URL_SUN  "http://sunsite.unc.edu/pub/Linux/docs/Raven/Raven01.html"
  set URL_SUN  "http://sunsite.unc.edu/pub/Linux/docs/Raven/"
# SSR01 broken until upgrade # ssr01 after
  set URL_SUN  "http://sunsite.unc.edu/pub/Linux/docs/Raven/"
  set URL_IMP  "http://sunsite.doc.ic.ac.uk/packages/linux/sunsite.unc-mirror/docs/Raven/"
  set URL_LTH  "http://beyond.malmo.lth.se/~gps/Raven"
  set URL_TDC  "http://www.users.dircon.co.uk/~trix"
  set URL_TRIX "http://trix.dircon.co.uk/Raven"
  set URL_LOC  "file:/usr/doc/Raven"
  set URL_CD1  "file:/cdrom/usr/doc/Raven"

  set desc "Browse the Raven magazine" 
  set B fn_gen_button	;# I hate long lines
  set W .w_fixed_window_1

$B $p [new_tag] "Raven published on sunsite"         "browse $W $URL_SUN"  $desc
$B $p [new_tag] "Raven preview in Lunds Sweden"      "browse $W $URL_LTH"  $desc
$B $p [new_tag] "Raven mirrored in Imperial College" "browse $W $URL_IMP"  $desc
$B $p [new_tag] "Raven in the tower"                 "browse $W $URL_TRIX" $desc
$B $p [new_tag] "Raven via home page"                "browse $W $URL_TDC"  $desc
$B $p [new_tag] "Raven locally"                      "browse $W $URL_LOC"  $desc
$B $p [new_tag] "Raven on CDROM"                     "browse $W $URL_CD1"  $desc
$B $p [new_tag] "Other URLS to view"                 "browse_more" "Other URLS"
}

proc browse_more {} {
	set p [ pop_up_frm .w2_more_URLS .frm "Browse More" ] ;# this window is static
	set B fn_gen_button	;# I hate long lines

	set W [new_tag .url_menu_]
	set name "sunsite.unc.edu"
	set desc "sunsite.unc.edu has loads of Linux stuff"
	set url  "http://sunsite.unc.edu/pub/Linux/docs"
	$B $p [new_tag] $name "browse $W $url"  $desc

	set W [new_tag .url_menu_]
	set name "Linux World"
	set desc "Linux World - a new printed mag from UK"
	set url  "http://www.eurodream.co.uk/"
	$B $p [new_tag] $name "browse $W $url"  $desc

	set W [new_tag .url_menu_]
	set name "Linux Journal"
	set desc "Linux Joural is the oldest and best"
	set url  "http://www.ssc.com"
	$B $p [new_tag] $name "browse $W $url"  $desc

	set W [new_tag .url_menu_]
	set name "HOWTO index"
	set desc "HOWTO index"
	set url  "http://sunsite.unc.edu/mdw"
	$B $p [new_tag] $name "browse $W $url"  $desc

	set W [new_tag .url_menu_]
	set name "Linux Gazette"
	set desc "Linux Gazette"
	set url  "http://www.linux.org.uk/lg/gazette_toc.html"
	$B $p [new_tag] $name "browse $W $url"  $desc
}

#-- create a new top level panel --#

proc pop_up_frm { panel {frame .frm} {title default} {icons default} } {
# create new top level popup panel with frame , OK button, ...
        set frm ${panel}$frame 
        set ok  ${panel}.ok
        set wr  ${panel}.wr

        if {"default"==$title} { set title $frm }
        if {"default"==$icons} { set icons $title }

        catch {destroy $panel}
        toplevel $panel
        wm title    $panel "$title"
        wm iconname $panel "$icons"
        bind $panel <3><3> "
                catch {destroy $panel}
        "
#       positionWindow $panel

        frame $frm
        button $ok -text "dismiss" -command "destroy $panel"
        pack $ok     -side top    -fill x
        pack $frm -in $panel -fill both -anchor w -expand 1
        bind $frm <Any-Enter> "focus $frm"
        return $frm
}

#-- pack_line --#
#-- pack_word --#

# you can have several lines in a word
# you can have several words in a line
# you have a frame for each
# a widget is already a frame
# pack it when you like, eg before adding contents ;# or never
# dont use pack -in, use nested.names
# then it just works
# except gen_field doesn-t fill properly

	proc pack_word frame { pack $frame -anchor nw -side left -fill y }
	proc pack_line frame { pack $frame -anchor nw -side top  -fill x }

#-- run commands --#

# This code is rather untidy
# BUGS sh -c is not the way to go
# should specify current working dirctory where the command is done
# eg cd ~/1996/0521/
# xterm can take a proper argv
# xterm needs a "stay_diplayed_after_command_exits" sub_mode
# xterm could add Currently Running(argv), simple list of commands shell,,,
# xterm terminal emulator with only 20 commands, plus fg/bg font_attr pallette
# xtrim parse(VT100) ESC codes, ignore others, ESC_goxy(cx,ry) ESC_fgbg(fg,bg) acs
# prtc  seperate shell script or curses utility


	#### --------------
	# what is the xterm syntax instead of the following
	# option --do_not_exit_when_command_does
	# --------
	##!/bin/sh
	## /usr/local/bin/prtc
	# echo -n "Press Return to continue ..."
	# read junk
	# --------

	proc run_xterm_prtc {cmd } { # 
		run_xterm_2 $cmd "$cmd;echo -n press-Return-to-continue;read junk"
	}

	# xterm can take argv as proper argv
	# so avoid the sh -c phase
	# build argv as list within tcl
	# todo!
	#	exec rxvt -T $title -e sh -c "$cmd" &
	# BUG # zombies
	# BUG # still

	proc run_xterm_2 { title cmd } { 
		exec xterm -title $title -e sh -c "$cmd" &
	}

	proc run_x {cmd} {
		exec sh -c "$cmd" &
	}


#-- message line --#

	proc fn_set_text { desc_obj str_76 } {
	#	add your own
	#	sometime
	}

#-- new_tag --#

	# GLOBAL VAR #
	set btn_tag_next 0

	proc new_tag {{prefix .btn_tag_}} {
		global btn_tag_next
		set btn_tag_next [expr 1 +  $btn_tag_next ]
		set tag "${prefix}$btn_tag_next"
	#	puts $tag
		return "$tag"
	}

#- fixup a verbose Tk3/Tk4 default --#

proc tk3_butEnter W {
	global tk_version 
	if [ expr $tk_version < 4 ] { tk_butEnter $W }
}

#-- create a new button --#

# this is what it all spins around
# button_id, button_text, button_desc, button_action
# commands could be pre-quoted strings or argv list
# commands could be "button_pressed btn_1234"
# range of button varients (all the same) for
# text buttons, gif buttons, text_in_var button
# +- disable-able (by id)
# +- text is expr (volatile, or track dependencies)
# expr :== sprint "dial_ppp %s" $dial_ppp_to 
# expr :== [ my_get_var_as_printable_button_text_sub_str dial_ppp_to ]
# expr :== fmt_str 
# expr :== fmt_str var_name	;# default, some capability, not complex
# expr :== fmt_str var_name var_name ...list...
# expr :== fmt_str expr_name expr_name ...list...
# this looks like polymorphic constructors for new_expr( db, id, style, fmt, fmt_argv )
# where style is the class expr_built_from_string_vars_and_exprs_for use in buttons and reports 
# I think TK wants the appn to develop its own list of named vars and exprs

proc fn_var_button {p name text_var command {desc "DESCRIPTION MISSING"}} {
	set btn $p$name
 	label $btn -textvariable $text_var -anchor nw -bd 1 -relief sunken -padx 3
	pack_line $btn 
	fn_gen_button_binds $btn $command $desc 
}

proc fn_gen_button {p nam text {command pwd} {desc "DESCRIPTION MISSING"}} {
	set btn $p$nam
 	label $btn -text         $text     -anchor nw -bd 1 -relief sunken -padx 3
	pack_line $btn 
	fn_gen_button_binds $btn $command $desc 
}

#-- code for when pressed --#

# how to turn a dumb label into a button
# GOOD: this is not motif 
# RULE: on press, button goes sunken
# RULE: the button you can now press looks like  a button (raised)
# ELSE:	the buttons elsewhere dont (sunken)
# RULE: cursor-focus-3 has it's own highlight
#
# labels look prettier than button widgets (nicer default font)
# I guess you could put any packable .gif or 8bit.pbm.on_screen_pbm_1175 as a button
# as long as it accepts $button_display configure -relief "raised" as "cursor focus"
# when command or desc contains a % sign all hell breaks loose
# thats because of bind, double them up on input

proc fn_gen_button_binds { name command desc } {
#
	bind $name <Any-Leave> "
		$name configure -relief sunken
	"
	bind $name <Any-Enter> "
		$name configure -relief raised
		fn_set_text .msg {$desc}
		fn_set_text .cmd {($name) $command}
#		tk3_butEnter %W
	"
	bind $name <Button-1> "
		$name configure -relief flat
		update idletasks
		eval {$command}
	"
	return $name
}

#-- create a text field --#

## BUG ## doesn t expand + fill properly

proc fn_gen_field {p name label var {desc "DESCRIPTION MISSING"}} {
	set frm "$p${name}" ;#".frame"
	set lbl "$p${name}.label"
	set fld "$p${name}.field"

	frame $frm -bd 2 -relief raised -bg white
	label $lbl -text $label -anchor e
	entry $fld -textvariable $var -relief sunken -bd 2
	bind $fld <Any-Enter> "focus $fld"
#	pack_word $lbl
	pack_line $fld
#	pack_word $fld
	pack_line $frm	;# callers job really
}

#-- create command buttons --#

proc fn_cmd_button {p name cmd {desc "DESCRIPTION MISSING"}} {
 	fn_gen_button $p $name $cmd "run_xterm \"$cmd\"" $desc
}

proc fn_cmd_button_x {p name cmd {desc "DESCRIPTION MISSING"}} {
 	fn_gen_button $p $name $cmd "run_x \"$cmd\"" $desc
}

proc fn_cmd_button_prtc {p name cmd {desc "DESCRIPTION MISSING"}} {
 	fn_gen_button $p $name $cmd "run_xterm_prtc \"$cmd\"" $desc
}

proc fn_cmd_button_pg {p name cmd {desc "DESCRIPTION MISSING"}} {
 	fn_gen_button $p $name $cmd "run_xless \"$cmd\"" $desc
}

###################
# needs other code elsewhere
# proc fn_cmd_button_txt {p name cmd {desc "DESCRIPTION MISSING"}} {
# 	global txt_run_text
#  	fn_gen_button $p $name $cmd "txt_run $txt_run_text \"$cmd\"" $desc
# }
# proc fn_cmd_button_win {p name cmd {desc "DESCRIPTION MISSING"}} {
# 	global txt_run_text
#  	fn_gen_button $p $name $cmd "txt_run_panel .panel \"$cmd\"" "$desc (own window"
# }
# proc fn_cmd_button_pan {p name panel cmd {desc "DESCRIPTION MISSING"}} {
#  	fn_gen_button $p $name $cmd "txt_run_panel $panel \"$cmd\"" "$desc (own window"
# }
# 
####################

if 1 {
	fn_dial_ppp_main {}
} else {
	toplevel .w1
	fn_dial_ppp_main .w1
}
