#!/usr/bin/make -f

# the only special thing is chmod 6750 dial_ppp
# the rest is to prevent any users reading chat_script passwords
# and to do the install

all: install

perms: ../dial_ppp ../chat_tdc
	chown root.dial_ppp ../dial_ppp
	chown root.dial_ppp ../dial_ppp.sh
	chown root.bin      ../chat_*	
	chmod 6750 ../dial_ppp		# SUID root from dial_ppp
	chmod 750 ../dial_ppp.sh	# allow read for group to debug
	chmod 600 ../chat_*		# SECRET root

../dial_ppp: dial_ppp.c
	make dial_ppp
	mv dial_ppp ..
	chown root.dial_ppp ../dial_ppp
	chmod 6750 ../dial_ppp
	-ln -s /etc/ppp/dial_ppp /usr/bin

../chat_tdc:
	cp -p chat_tdc-dist ../chat_tdc
	chown root.bin ../chat_tdc
	chmod 600 ../chat_tdc
	@echo " *****************************************"
	@echo " **** You must edit /etc/ppp/chat_tdc ****"
	@echo " *****************************************"

../dial_ppp.sh:
	cp -p dial_ppp.sh-dist ../dial_ppp.sh
	chown root.dial_ppp ../dial_ppp.sh
	chmod 750 ../dial_ppp.sh
	@echo " ********************************************"
	@echo " **** You must edit /etc/ppp/dial_ppp.sh ****"
	@echo " ********************************************"

install: ../dial_ppp ../chat_tdc ../dial_ppp.sh perms
